<?php

namespace OrganizationsManagement\Controller;

use OrganizationsManagement\Util\Utilities;
use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource;
use OrganizationsManagement\Service;

class Estado extends Simple {

    private $serviceEstado;

    public function __construct(Service\Estado $stateService){
        $this->serviceEstado = $stateService;
    }

    public function obtemPorIdPais(DTO\Request\Filter $request, DTO\Response $response){
        try {
            $filtro = $request->getFilterCriteria()->getConditions();
            $idPais  = Utilities::getValueInFilterDataSourceByName($filtro, 'COUNTRY_ID', true);
            $estados = array();

            if($idPais){
                $estados = $this->serviceEstado->obtemPorIdPais($idPais, $filtro);
            }

            $response->addDataSet(new DataSource\DataSet('states', $estados));
        } catch(\Exception $ex){
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
        }
    }
}