<?php
namespace OrganizationsManagement\Controller;

use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DataSource\DataSet;
use OrganizationsManagement\Util\InstanceProvider;


class NotificationServices{
    
    public function findNotificationServices(Request\Filter $request, Response $response)
    {
        try {
            $conditions = $request->getFilterCriteria()->getConditions();
            $serviceNotificationServices = InstanceProvider::getService()->getNotificationServices();
            $dataSet = $serviceNotificationServices->findNotificationServices($conditions);
            $response->addDataSet(new DataSet('notificationServices', $dataSet));
        } catch (Exception $ex) {
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }
    
    public function saveNotificationServices(Request\DataSet $request, Response $response)
    {
        try {
            $serviceNotificationServices = InstanceProvider::getService()->getNotificationServices();
            $row = $request->getDataSet()->getRows()[0];
            $id = empty($row['ID']) ? NULL : $row['ID'];
            $nmserviconotif = $row['NMSERVICONOTIF'];
            $idativo = $row['IDATIVO'];
            $dsserviconotif = $row['DSSERVICONOTIF'];
            $dataSet = $serviceNotificationServices->saveNotificationServices($id, $idativo, $dsserviconotif, $nmserviconotif);
            $response->addDataSet(new dataset('notificationServices', [$dataSet]));
        } catch (Exception $ex) {
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }
    
    public function deleteNotificationServices(Request\Row $request, Response $response)
    {
        try {
            $row = $request->getRow();
            $serviceNotificationServices = InstanceProvider::getService()->getNotificationServices();
            $serviceNotificationServices->deleteNotificationServices($row['ID']);
        } catch (Exception $ex) {
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }
    
    public function findNotificationServicesApp(Request\Filter $request, Response $response)
    {
        try {
            $conditions = $request->getFilterCriteria()->getConditions();
            $serviceNotificationServicesApp = InstanceProvider::getService()->getNotificationServices();
            $dataset = $serviceNotificationServicesApp->findNotificationServicesApp($conditions);
            $response->addDataSet(new DataSet ('notificationServicesApp', $dataset));
        } catch (Exception $ex) {
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
        
    }

    public function saveNotificationServicesApp(Request\DataSet $request, Response $response)
    {
        try {
            $serviceNotificationServicesApp =  InstanceProvider::getService()->getNotificationServices();
            $row = $request->getDataSet()->getRows()[0];
            $id = empty($row['ID']) ? NULL : $row['ID'];
            $idativo = $row['IDATIVO'];
            $nmservnotifappparam = $row['NMSERVNOTIFAPPPARAM'];
            $dsservnotifappparam = $row['DSSERVNOTIFAPPPARAM'];
            $nrserviconotif_id = $row['NRSERVICONOTIF_ID'];
            $dataSet =  $serviceNotificationServicesApp->saveNotificationServicesApp($id, $idativo, $nmservnotifappparam, $dsservnotifappparam, $nrserviconotif_id);
            $response->addDataSet(new DataSet('notificationServicesApp', [$dataSet]));
        } catch (Exception $ex) {
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }
    
    public function deleteNotificationServicesApp(Request\Row $request, Response $response)
    {
        try {
            $row = $request->getRow();
            $serviceNotificationServicesApp = InstanceProvider::getService()->getNotificationServices();
            $serviceNotificationServicesApp->deleteNotificationServicesApp($row['ID']);
        } catch (Exception $ex) {
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }
    
     public function findNotificationServicesDev(Request\Filter $request, Response $response)
    {
        try {
            $conditions = $request->getFilterCriteria()->getConditions();
            $serviceNotificationServicesDev = InstanceProvider::getService()->getNotificationServices();
            $dataset = $serviceNotificationServicesDev->findNotificationServicesDev($conditions);
            $response->addDataSet(new DataSet ('notificationServicesDev', $dataset));
        } catch (Exception $ex) {
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
        
    }

    public function saveNotificationServicesDev(Request\DataSet $request, Response $response)
    {
        try {
            $serviceNotificationServicesDev =  InstanceProvider::getService()->getNotificationServices();
            $row = $request->getDataSet()->getRows()[0];
            $id = empty($row['ID']) ? NULL : $row['ID'];
            $idativo = $row['IDATIVO'];
            $nmservnotifdispparam = $row['NMSERVNOTIFDISPPARAM'];
            $dsservnotifdispparam = $row['DSSERVNOTIFDISPPARAM'];
            $nrserviconotif_id = $row['NRSERVICONOTIF_ID'];
            $dataSet =  $serviceNotificationServicesDev->saveNotificationServicesDev($id, $idativo, $nmservnotifdispparam, $dsservnotifdispparam, $nrserviconotif_id);
            $response->addDataSet(new DataSet('notificationServicesDev', [$dataSet]));
        } catch (Exception $ex) {
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }
    
    public function deleteNotificationServicesDev(Request\Row $request, Response $response)
    {
        try {
            $row = $request->getRow();
            $serviceNotificationServicesDev = InstanceProvider::getService()->getNotificationServices();
            $serviceNotificationServicesDev->deleteNotificationServicesDev($row['ID']);
        } catch (Exception $ex) {
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }
}