<?php
namespace OrganizationsManagement\Util\Instance;

use Zeedhi\Framework\DependencyInjection\InstanceManager;
use OrganizationsManagement\Factory as Factories;


class Factory {
    /** @return  Factory */
    public static function getInstance()
    {
        return new static();
    }

    /** @return Factories\NotificationServices */
    public function getNotificationServices()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\NotificationServices');
    }

    public function getNotificationServicesApp()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\NotificationServicesApp');
    }

    public function getNotificationServicesDev()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\NotificationServicesDev');
    }

    public function getNotificationParametersProdOrg()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\NotificationParametersProdOrg');
    }

    public function getNotificationParametersAppProdOrg()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\NotificationParametersAppProdOrg');
    }

    public function getNotificationParametersProd()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\NotificationParametersProd');
    }

    public function getNotificationParametersAppProd()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\NotificationParametersAppProd');
    }

    /** @return Factories\ProdutoRepositorio */
    public function getProdutoRepositorio()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\ProdutoRepositorio');
    }

    /** @return Factories\Produto */
    public function getProduto()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\Produto');
    }

    /** @return Factories\ProdutoOrgVersao */
    public function getProdutoOrgVersao()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\ProdutoOrgVersao');
    }

    /** @return Factories\ConfigMedidaVariavel */
    public function getConfigMedidaVariavel()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\ConfigMedidaVariavel');
    }

    /** @return \OrganizationsManagement\Factory\ConfigColeta */
    public function getConfigColeta()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\ConfigColeta');
    }

    /** @return \OrganizationsManagement\Factory\ConfigColetaOrg */
    public function getConfigColetaOrg()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\ConfigColetaOrg');
    }

    public function getOmIntegracoes()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\OmIntegracoes');
    }
    public function getFctParametrogeral()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\FctParametrogeral');
    }
    public function getFctServicoOrca()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\FctServicoorca');
    }

    public function getBudgetItemFctItemorcamento()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\BudgetItemFctItemorcamento');
    }

    public function getItemorcaprodFctItemorcamento()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\ItemorcaprodFctItemorcamento');
    }

    /** @return Factories\AtualizacaoEstrutura */
    public function getAtualizacaoEstrutura()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\AtualizacaoEstrutura');
    }

    /** @return Factories\LinhaProduto */
    public function getLinhaProduto()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\LinhaProduto');
    }

    /** @return Factories\ParametroFilial */
    public function getParametroFilial()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\ParametroFilial');
    }

    /** @return Factories\ComandoEstrutura */
    public function getComandoEstrutura()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\ComandoEstrutura');
    }

    /** @return Factories\Parcliefas */
    public function getParcliefas()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\Parcliefas');
    }

    /** @return Factories\ColetaMedidaVariavel */
    public function getColetaMedidaVariavel()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\ColetaMedidaVariavel');
    }

    /** @return Factories\Organizacao */
    public function getOrganizacao()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\Organizacao');
    }

    /** @return Factories\ProdutoOrgElementoContrato */
    public function getProdutoOrgElementoContrato()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\ProdutoOrgElementoContrato');
    }

    /** @return Factories\OmParamOrg */
    public function getOmParamOrg()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\OmParamOrg');
    }

    /** @return Factories\Operclie */
    public function getOperclie()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\Operclie');
    }

    /** @return Factories\Estoque */
    public function getEstoque()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\Estoque');
    }

    /** @return Factories\Loja */
    public function getLoja()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\Loja');
    }

    /** @return Factories\Cliente */
    public function getCliente()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\Cliente');
    }

    /** @return Factories\BudgetItemPrices */
    public function getBudgetItemPrices()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Factory\BudgetItemPrices');
    }
}
